searchNodes=[{"doc":"Basic structures both useful for nostr relays and clients Takes care of: Cryptography SHA256 Schnorr Signatures Events Parsing Serialization Signing Validation Filters Parsing Serialization","ref":"NostrBasics.html","title":"NostrBasics","type":"module"},{"doc":"Crypto algorithms needed to communicate on the nostr network","ref":"NostrBasics.Crypto.html","title":"NostrBasics.Crypto","type":"module"},{"doc":"Computes SHA256 on a binary and returns it as a binary Examples iex&gt; &quot;6c7ab2f961a1bc3f13cdc08dc41c3f439adebd549a8ef1c089e81a5907376107&quot; ...&gt; |&gt; NostrBasics.Crypto . sha256 ( ) &lt;&lt; 0xab6a8f1d9e2b0333dff8e370ed6fdfe20b2e8008e045efb3fb3298c22f7569da :: 256 &gt;&gt;","ref":"NostrBasics.Crypto.html#sha256/1","title":"NostrBasics.Crypto.sha256/1","type":"function"},{"doc":"Represents the basic structure of anything that's being sent to/from relays","ref":"NostrBasics.Event.html","title":"NostrBasics.Event","type":"module"},{"doc":"Adds an ID to an event that doesn't have one Examples iex&gt; % NostrBasics.Event { ...&gt; pubkey : &lt;&lt; 0x5ab9f2efb1fda6bc32696f6f3fd715e156346175b93b6382099d23627693c3f2 :: 256 &gt;&gt; , ...&gt; created_at : ~U[2023-02-07 18:24:32Z] , ...&gt; kind : 1 , ...&gt; tags : [ ] , ...&gt; content : &quot;this is the content&quot; ...&gt; } ...&gt; |&gt; NostrBasics.Event . add_id % NostrBasics.Event { id : &quot;0f017fc299f6351efe9d5bfbfb36c0c7a1399627f9bec02c49b00d0ec98a5f34&quot; , pubkey : &lt;&lt; 0x5ab9f2efb1fda6bc32696f6f3fd715e156346175b93b6382099d23627693c3f2 :: 256 &gt;&gt; , created_at : ~U[2023-02-07 18:24:32Z] , kind : 1 , tags : [ ] , content : &quot;this is the content&quot; }","ref":"NostrBasics.Event.html#add_id/1","title":"NostrBasics.Event.add_id/1","type":"function"},{"doc":"Simplifies the creation of an event, adding the created_at and tags fields and requiring the bare minimum to do so Examples iex&gt; now = DateTime . utc_now ( ) ...&gt; pubkey = &lt;&lt; 0xEFC83F01C8FB309DF2C8866B8C7924CC8B6F0580AFDDE1D6E16E2B6107C2862C :: 256 &gt;&gt; ...&gt; event = NostrBasics.Event . create ( &quot;this is the content&quot; , pubkey ) ...&gt; %{ event | created_at : now } % NostrBasics.Event { id : nil , pubkey : &lt;&lt; 0xefc83f01c8fb309df2c8866b8c7924cc8b6f0580afdde1d6e16e2b6107c2862c :: 256 &gt;&gt; , kind : nil , created_at : now , tags : [ ] , content : &quot;this is the content&quot; , sig : nil }","ref":"NostrBasics.Event.html#create/2","title":"NostrBasics.Event.create/2","type":"function"},{"doc":"Creates an ID for an event that doesn't have one Examples iex&gt; % NostrBasics.Event { ...&gt; pubkey : &lt;&lt; 0x5ab9f2efb1fda6bc32696f6f3fd715e156346175b93b6382099d23627693c3f2 :: 256 &gt;&gt; , ...&gt; created_at : ~U[2023-02-07 18:24:32Z] , ...&gt; kind : 1 , ...&gt; tags : [ ] , ...&gt; content : &quot;this is the content&quot; ...&gt; } ...&gt; |&gt; NostrBasics.Event . create_id &quot;0f017fc299f6351efe9d5bfbfb36c0c7a1399627f9bec02c49b00d0ec98a5f34&quot;","ref":"NostrBasics.Event.html#create_id/1","title":"NostrBasics.Event.create_id/1","type":"function"},{"doc":"A structure an event has to be converted to prior to being SHA256'd, mainly for ID creation Examples iex&gt; % NostrBasics.Event { ...&gt; pubkey : &lt;&lt; 0x5ab9f2efb1fda6bc32696f6f3fd715e156346175b93b6382099d23627693c3f2 :: 256 &gt;&gt; , ...&gt; created_at : ~U[2023-02-07 18:24:32Z] , ...&gt; kind : 1 , ...&gt; tags : [ ] , ...&gt; content : &quot;this is the content&quot; ...&gt; } ...&gt; |&gt; NostrBasics.Event . json_for_id ~s([0,&quot;5ab9f2efb1fda6bc32696f6f3fd715e156346175b93b6382099d23627693c3f2&quot;,1675794272,1,[],&quot;this is the content&quot;])","ref":"NostrBasics.Event.html#json_for_id/1","title":"NostrBasics.Event.json_for_id/1","type":"function"},{"doc":"Converts a NIP-01 JSON string into a %Event{} Examples iex&gt; ~s({&quot;id&quot;:&quot;0f017fc299f6351efe9d5bfbfb36c0c7a1399627f9bec02c49b00d0ec98a5f34&quot;,&quot;pubkey&quot;:&quot;5ab9f2efb1fda6bc32696f6f3fd715e156346175b93b6382099d23627693c3f2&quot;,&quot;created_at&quot;:1675794272,&quot;kind&quot;:1,&quot;tags&quot;:[],&quot;content&quot;:&quot;this is the content&quot;}) ...&gt; |&gt; NostrBasics.Event . parse ( ) { :ok , % NostrBasics.Event { id : &quot;0f017fc299f6351efe9d5bfbfb36c0c7a1399627f9bec02c49b00d0ec98a5f34&quot; , pubkey : &lt;&lt; 0x5ab9f2efb1fda6bc32696f6f3fd715e156346175b93b6382099d23627693c3f2 :: 256 &gt;&gt; , created_at : ~U[2023-02-07 18:24:32Z] , kind : 1 , tags : [ ] , content : &quot;this is the content&quot; } }","ref":"NostrBasics.Event.html#parse/1","title":"NostrBasics.Event.parse/1","type":"function"},{"doc":"","ref":"NostrBasics.Event.html#t:t/0","title":"NostrBasics.Event.t/0","type":"type"},{"doc":"Event id conversion functions","ref":"NostrBasics.Event.Id.html","title":"NostrBasics.Event.Id","type":"module"},{"doc":"Converts a bech32 event id into its binary format Examples iex&gt; &quot;note19e93faw4ffqepsqsrwrnstd3ee00nmzakwwuyfjm43dankgummfqms4p6q&quot; ...&gt; |&gt; NostrBasics.Event.Id . from_bech32 { :ok , &quot;note&quot; , &lt;&lt; 0x2e4b14f5d54a4190c0101b87382db1ce5ef9ec5db39dc2265bac5bd9d91cded2 :: 256 &gt;&gt; }","ref":"NostrBasics.Event.Id.html#from_bech32/1","title":"NostrBasics.Event.Id.from_bech32/1","type":"function"},{"doc":"Converts a bech32 event id into its binary format Examples iex&gt; &quot;note19e93faw4ffqepsqsrwrnstd3ee00nmzakwwuyfjm43dankgummfqms4p6q&quot; ...&gt; |&gt; NostrBasics.Event.Id . from_bech32! &lt;&lt; 0x2e4b14f5d54a4190c0101b87382db1ce5ef9ec5db39dc2265bac5bd9d91cded2 :: 256 &gt;&gt;","ref":"NostrBasics.Event.Id.html#from_bech32!/1","title":"NostrBasics.Event.Id.from_bech32!/1","type":"function"},{"doc":"Converts an event binary id into a bech32 format Examples iex&gt; &lt;&lt; 0x2e4b14f5d54a4190c0101b87382db1ce5ef9ec5db39dc2265bac5bd9d91cded2 :: 256 &gt;&gt; ...&gt; |&gt; NostrBasics.Event.Id . to_bech32 ( &quot;note&quot; ) &quot;note19e93faw4ffqepsqsrwrnstd3ee00nmzakwwuyfjm43dankgummfqms4p6q&quot; iex&gt; &quot;2e4b14f5d54a4190c0101b87382db1ce5ef9ec5db39dc2265bac5bd9d91cded2&quot; ...&gt; |&gt; NostrBasics.Event.Id . to_bech32 ( &quot;note&quot; ) &quot;note19e93faw4ffqepsqsrwrnstd3ee00nmzakwwuyfjm43dankgummfqms4p6q&quot;","ref":"NostrBasics.Event.Id.html#to_bech32/2","title":"NostrBasics.Event.Id.to_bech32/2","type":"function"},{"doc":"Does its best to convert any event id format to binary, issues an error if it can't Examples iex&gt; &quot;note1qkjgra6cm5ms6m88kqdapfjnxm8q50lcurevtpvm4f6pfs8j5sxq90f098&quot; ...&gt; |&gt; NostrBasics.Event.Id . to_binary ( ) { :ok , &quot;note&quot; , &lt;&lt; 0x05a481f758dd370d6ce7b01bd0a65336ce0a3ff8e0f2c5859baa7414c0f2a40c :: 256 &gt;&gt; }","ref":"NostrBasics.Event.Id.html#to_binary/1","title":"NostrBasics.Event.Id.to_binary/1","type":"function"},{"doc":"Converts any type of event id into a hex format Examples iex&gt; &lt;&lt; 0x2e4b14f5d54a4190c0101b87382db1ce5ef9ec5db39dc2265bac5bd9d91cded2 :: 256 &gt;&gt; ...&gt; |&gt; NostrBasics.Event.Id . to_hex ( ) { :ok , nil , &quot;2e4b14f5d54a4190c0101b87382db1ce5ef9ec5db39dc2265bac5bd9d91cded2&quot; } iex&gt; &quot;note19e93faw4ffqepsqsrwrnstd3ee00nmzakwwuyfjm43dankgummfqms4p6q&quot; ...&gt; |&gt; NostrBasics.Event.Id . to_hex { :ok , &quot;note&quot; , &quot;2e4b14f5d54a4190c0101b87382db1ce5ef9ec5db39dc2265bac5bd9d91cded2&quot; }","ref":"NostrBasics.Event.Id.html#to_hex/1","title":"NostrBasics.Event.Id.to_hex/1","type":"function"},{"doc":"Converts a bech32 event id into a hex string format Examples iex&gt; &quot;note19e93faw4ffqepsqsrwrnstd3ee00nmzakwwuyfjm43dankgummfqms4p6q&quot; ...&gt; |&gt; NostrBasics.Event.Id . to_hex! &quot;2e4b14f5d54a4190c0101b87382db1ce5ef9ec5db39dc2265bac5bd9d91cded2&quot;","ref":"NostrBasics.Event.Id.html#to_hex!/1","title":"NostrBasics.Event.Id.to_hex!/1","type":"function"},{"doc":"Turns raw events from JSON websocket messages into elixir structs","ref":"NostrBasics.Event.Parser.html","title":"NostrBasics.Event.Parser","type":"module"},{"doc":"Converts a NIP-01 JSON string into a %Event{} Examples iex&gt; ~s({&quot;id&quot;:&quot;0f017fc299f6351efe9d5bfbfb36c0c7a1399627f9bec02c49b00d0ec98a5f34&quot;,&quot;pubkey&quot;:&quot;5ab9f2efb1fda6bc32696f6f3fd715e156346175b93b6382099d23627693c3f2&quot;,&quot;created_at&quot;:1675794272,&quot;kind&quot;:1,&quot;tags&quot;:[],&quot;content&quot;:&quot;this is the content&quot;}) ...&gt; |&gt; NostrBasics.Event.Parser . parse ( ) { :ok , % NostrBasics.Event { id : &quot;0f017fc299f6351efe9d5bfbfb36c0c7a1399627f9bec02c49b00d0ec98a5f34&quot; , pubkey : &lt;&lt; 0x5ab9f2efb1fda6bc32696f6f3fd715e156346175b93b6382099d23627693c3f2 :: 256 &gt;&gt; , created_at : ~U[2023-02-07 18:24:32Z] , kind : 1 , tags : [ ] , content : &quot;this is the content&quot; } }","ref":"NostrBasics.Event.Parser.html#parse/1","title":"NostrBasics.Event.Parser.parse/1","type":"function"},{"doc":"Signs events, making sure they're going to be accepted on the nostr network as the user's own","ref":"NostrBasics.Event.Signer.html","title":"NostrBasics.Event.Signer","type":"module"},{"doc":"Applies the schnorr signatures to an event and adds signature to it if successful Examples iex&gt; private_key = &lt;&lt; 0x4e22da43418dd934373cbb38a5ab13059191a2b3a51c5e0b67eb1334656943b8 :: 256 &gt;&gt; ...&gt; % NostrBasics.Event { ...&gt; id : &quot;0f017fc299f6351efe9d5bfbfb36c0c7a1399627f9bec02c49b00d0ec98a5f34&quot; , ...&gt; pubkey : &lt;&lt; 0x5ab9f2efb1fda6bc32696f6f3fd715e156346175b93b6382099d23627693c3f2 :: 256 &gt;&gt; , ...&gt; kind : 1 , ...&gt; created_at : ~U[2023-02-07 18:24:32.596503Z] , ...&gt; tags : [ ] , ...&gt; content : &quot;this is the content&quot; ...&gt; } ...&gt; |&gt; NostrBasics.Event.Signer . sign_event ( private_key ) { :ok , % NostrBasics.Event { id : &quot;0f017fc299f6351efe9d5bfbfb36c0c7a1399627f9bec02c49b00d0ec98a5f34&quot; , pubkey : &lt;&lt; 0x5ab9f2efb1fda6bc32696f6f3fd715e156346175b93b6382099d23627693c3f2 :: 256 &gt;&gt; , created_at : ~U[2023-02-07 18:24:32.596503Z] , kind : 1 , tags : [ ] , content : &quot;this is the content&quot; , sig : &lt;&lt; 0x985a5ffea93ccebaab4875c973186fac0e066a26222ddf932b8b5a98782a181baa1496394b13134e74f86a8b816bfccff152c7e66ef02e72bb9ae7db8d843680 :: 512 &gt;&gt; } }","ref":"NostrBasics.Event.Signer.html#sign_event/2","title":"NostrBasics.Event.Signer.sign_event/2","type":"function"},{"doc":"Makes sure a signature is valid","ref":"NostrBasics.Event.Validator.html","title":"NostrBasics.Event.Validator","type":"module"},{"doc":"Applies Schnorr signatures with the public key and the signature, making sure the event is properly signed Examples iex&gt; % NostrBasics.Event { ...&gt; id : &quot;0f017fc299f6351efe9d5bfbfb36c0c7a1399627f9bec02c49b00d0ec98a5f34&quot; , ...&gt; pubkey : &lt;&lt; 0x5ab9f2efb1fda6bc32696f6f3fd715e156346175b93b6382099d23627693c3f2 :: 256 &gt;&gt; , ...&gt; created_at : ~U[2023-02-07 18:24:32.596503Z] , ...&gt; kind : 1 , ...&gt; tags : [ ] , ...&gt; content : &quot;this is the content&quot; , ...&gt; sig : &lt;&lt; 0x985a5ffea93ccebaab4875c973186fac0e066a26222ddf932b8b5a98782a181baa1496394b13134e74f86a8b816bfccff152c7e66ef02e72bb9ae7db8d843680 :: 512 &gt;&gt; ...&gt; } ...&gt; |&gt; NostrBasics.Event.Validator . validate_event ( ) :ok","ref":"NostrBasics.Event.Validator.html#validate_event/1","title":"NostrBasics.Event.Validator.validate_event/1","type":"function"},{"doc":"Recreates the event's ID and makes sur it's the same as the one already in the structure Examples iex&gt; % NostrBasics.Event { ...&gt; id : &quot;0f017fc299f6351efe9d5bfbfb36c0c7a1399627f9bec02c49b00d0ec98a5f34&quot; , ...&gt; pubkey : &lt;&lt; 0x5ab9f2efb1fda6bc32696f6f3fd715e156346175b93b6382099d23627693c3f2 :: 256 &gt;&gt; , ...&gt; created_at : ~U[2023-02-07 18:24:32.596503Z] , ...&gt; kind : 1 , ...&gt; tags : [ ] , ...&gt; content : &quot;this is the content&quot; ...&gt; } ...&gt; |&gt; NostrBasics.Event.Validator . validate_id ( ) :ok iex&gt; % NostrBasics.Event { ...&gt; id : &quot;0000f&quot; , ...&gt; pubkey : &lt;&lt; 0x5ab9f2efb1fda6bc32696f6f3fd715e156346175b93b6382099d23627693c3f2 :: 256 &gt;&gt; , ...&gt; created_at : ~U[2023-02-07 18:24:32.596503Z] , ...&gt; kind : 1 , ...&gt; tags : [ ] , ...&gt; content : &quot;this is the content&quot; ...&gt; } ...&gt; |&gt; NostrBasics.Event.Validator . validate_id ( ) { :error , &quot;generated ID and the one in the event don&#39;t match&quot; }","ref":"NostrBasics.Event.Validator.html#validate_id/1","title":"NostrBasics.Event.Validator.validate_id/1","type":"function"},{"doc":"","ref":"NostrBasics.Event.Validator.html#validate_signature/1","title":"NostrBasics.Event.Validator.validate_signature/1","type":"function"},{"doc":"Details of a client subscription request to a relay","ref":"NostrBasics.Filter.html","title":"NostrBasics.Filter","type":"module"},{"doc":"Converts a NIP-01 JSON REQ string into a structured Filter Examples iex&gt; ~s({&quot;authors&quot;:[&quot;5ab9f2efb1fda6bc32696f6f3fd715e156346175b93b6382099d23627693c3f2&quot;],&quot;kinds&quot;:[1],&quot;limit&quot;:10}) ...&gt; |&gt; NostrBasics.Filter . from_req ( &quot;a_subscription_id&quot; ) { :ok , % NostrBasics.Filter { subscription_id : &quot;a_subscription_id&quot; , kinds : [ 1 ] , authors : [ &lt;&lt; 0x5ab9f2efb1fda6bc32696f6f3fd715e156346175b93b6382099d23627693c3f2 :: 256 &gt;&gt; ] , limit : 10 } }","ref":"NostrBasics.Filter.html#from_req/2","title":"NostrBasics.Filter.from_req/2","type":"function"},{"doc":"Converts a structured Filter into a NIP-01 JSON REQ string Examples iex&gt; % NostrBasics.Filter { ...&gt; subscription_id : &quot;a_subscription_id&quot; , ...&gt; kinds : [ 1 ] , ...&gt; authors : [ &lt;&lt; 0x5ab9f2efb1fda6bc32696f6f3fd715e156346175b93b6382099d23627693c3f2 :: 256 &gt;&gt; ] , ...&gt; limit : 10 ...&gt; } ...&gt; |&gt; NostrBasics.Filter . to_query { :ok , ~s({&quot;authors&quot;:[&quot;5ab9f2efb1fda6bc32696f6f3fd715e156346175b93b6382099d23627693c3f2&quot;],&quot;kinds&quot;:[1],&quot;limit&quot;:10}) }","ref":"NostrBasics.Filter.html#to_query/1","title":"NostrBasics.Filter.to_query/1","type":"function"},{"doc":"","ref":"NostrBasics.Filter.html#t:t/0","title":"NostrBasics.Filter.t/0","type":"type"},{"doc":"Converts a string request to a structured subscription filter and back","ref":"NostrBasics.Filter.Parser.html","title":"NostrBasics.Filter.Parser","type":"module"},{"doc":"Examples iex&gt; ~s({&quot;authors&quot;:[&quot;5ab9f2efb1fda6bc32696f6f3fd715e156346175b93b6382099d23627693c3f2&quot;],&quot;kinds&quot;:[1],&quot;limit&quot;:10}) ...&gt; |&gt; NostrBasics.Filter.Parser . from_req ( &quot;a_subscription_id&quot; ) { :ok , % NostrBasics.Filter { subscription_id : &quot;a_subscription_id&quot; , kinds : [ 1 ] , authors : [ &lt;&lt; 0x5ab9f2efb1fda6bc32696f6f3fd715e156346175b93b6382099d23627693c3f2 :: 256 &gt;&gt; ] , limit : 10 } }","ref":"NostrBasics.Filter.Parser.html#from_req/2","title":"NostrBasics.Filter.Parser.from_req/2","type":"function"},{"doc":"Transaforms a %Filter{} into a NIP-01 JSON string","ref":"NostrBasics.Filter.Serializer.html","title":"NostrBasics.Filter.Serializer","type":"module"},{"doc":"Converts a structured Filter into a NIP-01 JSON REQ string Examples iex&gt; % NostrBasics.Filter { ...&gt; subscription_id : &quot;a_subscription_id&quot; , ...&gt; kinds : [ 1 ] , ...&gt; authors : [ &lt;&lt; 0x5ab9f2efb1fda6bc32696f6f3fd715e156346175b93b6382099d23627693c3f2 :: 256 &gt;&gt; ] , ...&gt; limit : 10 ...&gt; } ...&gt; |&gt; NostrBasics.Filter.Serializer . to_req { :ok , ~s({&quot;authors&quot;:[&quot;5ab9f2efb1fda6bc32696f6f3fd715e156346175b93b6382099d23627693c3f2&quot;],&quot;kinds&quot;:[1],&quot;limit&quot;:10}) }","ref":"NostrBasics.Filter.Serializer.html#to_req/1","title":"NostrBasics.Filter.Serializer.to_req/1","type":"function"},{"doc":"A way to represent binaries in a human readable format that fits what's found on the web related to keys and addresses Example: &lt;&lt; 0x181DCB172F5B56DB39B6C8544068FEE69928556230B41E115BDB22BF82A06FF3 :: 256 &gt;&gt; instead of &lt;&lt; 24 , 29 , 203 , 23 , 47 , 91 , 86 , 219 , 57 , 182 , 200 , 84 , 64 , 104 , 254 , 230 , 153 , 40 , 85 , 98 , 48 , 180 , 30 , 17 , 91 , 219 , 34 , 191 , 130 , 160 , 111 , 243 &gt;&gt;","ref":"NostrBasics.HexBinary.html","title":"NostrBasics.HexBinary","type":"module"},{"doc":"Converts a binary string into a %HexBinary{} that the inspector will print in a compact way Examples iex&gt; &lt;&lt; 24 , 29 , 203 , 23 , 47 , 91 , 86 , 219 , 57 , 182 , 200 , 84 , 64 , 104 , 254 , 230 , 153 , 40 , 85 , 98 , 48 , 180 , 30 , 17 , 91 , 219 , 34 , 191 , 130 , 160 , 111 , 243 &gt;&gt; ...&gt; |&gt; NostrBasics.HexBinary . from_binary ( ) % HexBinary { data : &lt;&lt; 0x181DCB172F5B56DB39B6C8544068FEE69928556230B41E115BDB22BF82A06FF3 :: 256 &gt;&gt; }","ref":"NostrBasics.HexBinary.html#from_binary/1","title":"NostrBasics.HexBinary.from_binary/1","type":"function"},{"doc":"Basic structures both useful for nostr relays and clients Takes care of: Cryptography SHA256 Schnorr Signatures Events Parsing Serialization Signing Validation Filters Parsing Serialization","ref":"readme.html","title":"NostrBasics","type":"extras"},{"doc":"The package can be installed by adding nostr_basics to your list of dependencies in mix.exs : def deps do [ { :nostr_basics , &quot;~&gt; 0.1.0&quot; } ] end","ref":"readme.html#installation","title":"NostrBasics - Installation","type":"extras"}]